import { uniq } from '../util.js';
export function simplifyEnumAndConst(node) {
    const { const: _const, enum: _enum, ...rest } = node;
    const combined = combineConstAndEnum(node);
    if (combined.length === 0)
        return rest;
    else if (combined.length === 1)
        return { ...rest, const: combined[0] };
    else {
        if (node.type === 'boolean'
            &&
                combined.includes(false)
            &&
                combined.includes(true))
            // This enum can be removed in favor of generic boolean
            return { ...rest };
        else
            return { ...rest, enum: combined };
    }
}
export function mergeConstEnumUnion(nodes) {
    const arrays = nodes.map(node => combineConstAndEnum(node));
    if (arrays.some(arr => arr.length === 0))
        // One of the nodes doesn't have const or enum, so all other const and
        // enums are irrelevant in a union.
        return [];
    return uniq([].concat(...arrays));
}
// TODO: This shouldn't union but _intersect_ enum and const
export function combineConstAndEnum(pseudoNode) {
    return uniq([
        ...(pseudoNode.const != null ? [pseudoNode.const] : []),
        ...(pseudoNode.enum != null ? pseudoNode.enum : []),
    ]);
}
