import { mergeAnnotations } from '../annotation.js';
import { intersection } from '../util.js';
export function intersectConstEnum(nodes) {
    if (nodes.length === 0)
        throw new Error("Cannot intersect const and enum from an empty array of nodes");
    if (nodes.length === 1)
        return nodes[0];
    const elements = nodes
        .map((node) => typeof node.const !== 'undefined'
        ? [node.const]
        : typeof node.enum !== 'undefined'
            ? node.enum
            : undefined)
        .filter((v) => !!v);
    const constEnum = elements.slice(1).reduce((prev, cur) => intersection(prev, cur), elements[0]);
    return {
        type: nodes[0].type,
        ...(constEnum.length === 1 ? { const: constEnum[0] } : {}),
        ...(constEnum.length !== 1 ? { enum: constEnum } : {}),
        ...mergeAnnotations(nodes),
    };
}
